import asyncio
from selenium import webdriver
from selenium.webdriver.firefox.options import Options
from funciones.mainselenium import *


def abrir_navegador(headless=False):
    opciones = Options()

    opciones.headless = headless

    driver = webdriver.Firefox(firefox_profile=os.getenv("RUTA_PERFIL"),
                               options=opciones,
                               executable_path=os.getenv("RUTA_GECKO"))

    driver.get("https://web.whatsapp.com/")

    sesion_iniciada = False

    while sesion_iniciada is False:
        try:
            driver.find_element_by_css_selector(ids['verificar_sesion'])
            sesion_iniciada = True
            print("<<<Sesion iniciada>>>")
        except:
            continue

    return driver


async def iniciar(loop, *args):
    print(f"[[ Tareas a ejecutar: {len(args)} ]]")

    tareas = [coro[0](*coro[1]) for coro in args]

    try:
        await asyncio.gather(*tareas)

        loop.run_forever()
    except Exception as e:
        print("CERRANDING")
        loop.stop()


async def frenar_loop(loop):
    """Se encarga de frenar un loop que esta corriendo, finalizando correctamente todas las tareas."""

    tasks = [t for t in asyncio.all_tasks() if t is not
             asyncio.current_task()]

    [task.cancel() for task in tasks]

    await asyncio.gather(*tasks)

    loop.stop()
