import tarfile
import requests
import os
import platform
import stat
from bs4 import BeautifulSoup
import sys

REPOSITORIO = "http://libs.airtrack.com.ar/atwsp/"
ARQUITECTURA = sys.platform

GECKODRIVER_URL = None
if ARQUITECTURA == "linux":
    GECKODRIVER_URL = "https://github.com/mozilla/geckodriver/releases/download/v0.29.1/geckodriver-v0.29.1-linux64.tar.gz"

elif ARQUITECTURA.startswith("win"):
    GECKODRIVER_URL = "https://github.com/mozilla/geckodriver/releases/download/v0.29.1/geckodriver-v0.29.1-win64.zip"

def obtener_versiones():
    req = requests.get(REPOSITORIO)

    if req.status_code == 200:
        parseado = BeautifulSoup(req.text, 'html.parser')
        links = parseado.find_all("a")
        versiones = [link['href'] for link in links if link['href'] != "../"]
        return enumerate(versiones), versiones

    else:
        print("Fallo al obtener las versiones de AtWsp, libs.airtrack.com.ar esta caido?")
        quit()


versiones_enum, versiones = obtener_versiones()
[print(f"[{i}] {v}") for i, v in versiones_enum]

try:
    version_elegida = int(input("\nIngresar el numero del archivo a descargar>> "))
    version_atwsp = versiones[version_elegida]
except (ValueError, Exception):
    print("Ingresa un numero valido por favor.")
    quit()

print(f"<< Version: {version_atwsp} >>")


def descargar(url, archivo):
    with open(archivo, "wb") as file:
        response = requests.get(url)
        file.write(response.content)


def extraer(archivo, destino):
    try:
        with tarfile.open(archivo, "r:gz") as tar:
            tar.extractall(destino)
    except Exception as error:
        print(f"Error en {extraer.__name__}: {error}")


# descargar(f"{REPOSITORIO}{version_atwsp}", version_atwsp)
# extraer(version_atwsp, version_atwsp.rstrip(".tar.gz"))
descargar(GECKODRIVER_URL, "geckodriver")
